package com.mortals.xhx.common.code;

import java.util.LinkedHashMap;
import java.util.Map;

/**
 * 产品资源部署
 *
 * @author: zxfei
 * @date: 2024/9/14 14:21
 */
public enum ProductDisEnum {
    网关服务("smart-gateway", "gateway-platform"),
    基础服务("base-manager", "base-platform"),
    门户服务("portal-manager", "portal-platform"),
    样表服务("sample-form-manager", "sample-form-manager"),


    ;
    private String value;
    private String desc;

    ProductDisEnum(String value, String desc) {
        this.value = value;
        this.desc = desc;
    }

    public String getValue() {
        return this.value;
    }

    public String getDesc() {
        return this.desc;
    }

    public static ProductDisEnum getByValue(String value) {
        for (ProductDisEnum productDisEnum : ProductDisEnum.values()) {
            if (productDisEnum.getValue().equals(value)) {
                return productDisEnum;
            }
        }
        return null;
    }

    /**
     * 获取Map集合
     *
     * @param eItem 不包含项
     * @return
     */
    public static Map<String, String> getEnumMap(String... eItem) {
        Map<String, String> resultMap = new LinkedHashMap<>();
        for (ProductDisEnum item : ProductDisEnum.values()) {
            try {
                boolean hasE = false;
                for (String e : eItem) {
                    if (item.getValue().equals(e)) {
                        hasE = true;
                        break;
                    }
                }
                if (!hasE) {
                    resultMap.put(item.getValue() + "", item.getDesc());
                }
            } catch (Exception ex) {

            }
        }
        return resultMap;
    }
}