package com.mortals.xhx.common.utils;

import cn.hutool.core.io.FileUtil;
import lombok.extern.slf4j.Slf4j;
import org.apache.commons.compress.archivers.tar.TarArchiveEntry;
import org.apache.commons.compress.archivers.tar.TarArchiveInputStream;
import org.apache.commons.compress.compressors.gzip.GzipCompressorInputStream;
import org.apache.commons.io.IOUtils;

import java.io.File;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.InputStream;
import java.util.HashSet;
import java.util.Set;

@Slf4j
public class ZipUtils {

    public static Set<String> localFiles = null;

    /**
     * 解压tar.gz压缩包
     *
     * @param fileName
     * @param unZipPath
     * @return
     */
    public static Set<String> unGzip(String fileName, String unZipPath) {
        Set<String> set = new HashSet<>();
        try {

            InputStream inputStream = FileUtil.getInputStream(fileName);
            TarArchiveInputStream fin = new TarArchiveInputStream(new GzipCompressorInputStream(inputStream));
            log.info("********开始执行gzip");
            TarArchiveEntry entry;
            // 将 tar 文件解压到 extractPath 目录下
            while ((entry = fin.getNextTarEntry()) != null) {
                if (entry.isDirectory()) {
                    continue;
                }
                //目标文件位置
                File curfile = new File(unZipPath + entry.getName());
                File parent = curfile.getParentFile();
                log.info("***文件保存的路径" + curfile.getAbsolutePath());
                if (!parent.exists()) {
                    parent.mkdirs();
                }
                // 将文件写出到解压的目录
                IOUtils.copy(fin, new FileOutputStream(curfile));
                set.add(curfile.getAbsolutePath());
            }


        } catch (IOException e) {
            e.printStackTrace();
        }
        if (localFiles == null) {
            localFiles = set;
        } else {
            localFiles.addAll(set);
        }

        return set;
    }


    /**
     * 解压tar.gz压缩包
     *
     * @param inputStream
     * @param unZipPath
     * @return
     */
    public static Set<String> unGzip(InputStream inputStream, String unZipPath) {
        Set<String> set = new HashSet<>();
        try {
            TarArchiveInputStream fin = new TarArchiveInputStream(new GzipCompressorInputStream(inputStream));
            log.info("********开始执行gzip");
            TarArchiveEntry entry;
            // 将 tar 文件解压到 extractPath 目录下
            while ((entry = fin.getNextTarEntry()) != null) {
                if (entry.isDirectory()) {
                    continue;
                }
                //目标文件位置
                File curfile = new File(unZipPath + entry.getName());
                File parent = curfile.getParentFile();
                log.info("***文件保存的路径" + curfile.getAbsolutePath());
                if (!parent.exists()) {
                    parent.mkdirs();
                }
                // 将文件写出到解压的目录
                IOUtils.copy(fin, new FileOutputStream(curfile));
                set.add(curfile.getAbsolutePath());
            }


        } catch (IOException e) {
            log.error("解压tar.gz文件失败", e);
        }
        if (localFiles == null) {
            localFiles = set;
        } else {
            localFiles.addAll(set);
        }

        return set;
    }



    // 解压tar包
    public Set<String> unTar(String fileName, String unZipPath) {
        Set<String> set = new HashSet<>();
        try {
            InputStream inputStream = FileUtil.getInputStream(fileName);

            TarArchiveInputStream fin = new TarArchiveInputStream(inputStream);
            log.info("********开始执行tar");
            // File extraceFolder = new File(unZipPath);
            TarArchiveEntry entry;

            // 将 tar 文件解压到 extractPath 目录下
            while ((entry = fin.getNextTarEntry()) != null) {
                if (entry.isDirectory()) {
                    continue;
                }
               log.info("*********创建目录开始" + unZipPath);
                boolean flag = FileUtil.exist(unZipPath);
               log.info("***********解压目录创建结束" + flag);
               log.info("***文件名称" + entry.getName());
                File curfile = new File(unZipPath + entry.getName());
                File parent = curfile.getParentFile();
               log.info("***文件保存的路径" + curfile.getAbsolutePath());
                if (!parent.exists()) {
                    parent.mkdirs();
                }
                set.add(curfile.getAbsolutePath());
                // 将文件写出到解压的目录
                IOUtils.copy(fin, new FileOutputStream(curfile));
            }

            //fin.close();


        } catch (IOException e) {
            e.printStackTrace();
        }
        if (localFiles == null) {
            localFiles = set;
        } else {
            localFiles.addAll(set);
        }

        return set;
    }


    public static void main(String[] args) {
        String fileName = "E:\\pic\\zip\\base-manager.tar.gz";

        String unZipPath = "E:\\pic\\zip\\";

        ZipUtils.unGzip(fileName, unZipPath);

    }

}
